#include <stdio.h>
#include <stdlib.h>
#include <string.h>

class Optab
{ public:  Optab(){ opers[0]="ADD\0"; opers[1]="AND\0"; opers[2]="COMP";
                    opers[3]="DIV\0"; opers[4]="J\0\0\0"; opers[5]="JEQ\0";
                    opers[6]="JGT\0"; opers[7]="JLT\0"; opers[8]="JSUB";
                    opers[9]="LDA\0"; opers[10]="LDCH"; opers[11]="LDL\0";
                    opers[12]="LDX\0"; opers[13]="MUL\0"; opers[14]="OR\0\0";
                    opers[15]="RD\0\0"; opers[16]="RSUB"; opers[17]="STA\0";
                    opers[18]="STCH"; opers[19]="STL\0"; opers[20]="STX\0";
                    opers[21]="SUB\0"; opers[22]="TD\0\0"; opers[23]="TIX\0";
                    opers[24]="WD\0\0";

                    codes[0]="18"; codes[1]="40"; codes[2]="28";
                    codes[3]="24"; codes[4]="3C"; codes[5]="30";
                    codes[6]="34"; codes[7]="38"; codes[8]="48";
                    codes[9]="00"; codes[10]="50"; codes[11]="08";
                    codes[12]="04"; codes[13]="20"; codes[14]="44";
                    codes[15]="D8"; codes[16]="4C"; codes[17]="0C";
                    codes[18]="54"; codes[19]="14"; codes[20]="10";
                    codes[21]="1C"; codes[22]="E0"; codes[23]="2C";
                    codes[24]="DC";
                  }
                    
           char opers[25][5];
           char codes[25][3];
           char *search(char *chk);
};

char *Optab::search(char *chk)
{ int i;

  for (i=0;strcmp(opers[i],chk);i++)
   ;
  if (i==25)
   return NULL;
   else
    return codes[i];
}

struct sss { char symbol[9];
             int loc;
             struct sss *next;
           };

class Symtab
{ public:  Symtab()
           { head=NULL;
           }

           struct sss *head;
           insert(char *,int);
           int search(char *);
};

Symtab::insert(char *a,int locctr)
{ struct sss *p;
  int i;

  p=(struct sss *) malloc(sizeof(struct sss));
  for (i=0;i<9;i++)
   p->symbol[i]=a[i];
  p->loc=locctr;
  p->next=NULL;

  if (head==NULL)
   head=p;
   else { p->next=head->next;
          head=p;
	}
}

int Symtab::search(char *old)
{ struct sss *p;

  p=head;
  while (strcmp(p->symbol,old))
   p=p->next;
  if (!p)
   return 0;
  return p->loc;
}

class Symtab symb_table;
class Optab op_table;

class Source_Line
{ public:  Source_Line() {/* line=NULL;
                           label=NULL;
                           oper=NULL;
                           operand=NULL;
                           comment=NULL;
			   commnt=0;
                          */
                         }
 	   char line[67];
           char label[8];
	   char oper[6];
           char operand[19];
           char comment[31];
           int commnt;
           parser(char *c);
};

Source_Line::parser(char *c)
{ int i;

  for (i=0;i<8;i++)
  { label[i]=c[i]; line[i]=c[i]; }
  for (;i<14;i++)
  { oper[i-8]=c[i]; line[i]=c[i]; }
  for (;i<33;i++)
  { operand[i-14]=c[i]; line[i]=c[i]; }
  for (;i<67;i++)
  { comment[i-33]=c[i]; line[i]=c[i]; }
  if (c[0]=='.')
   commnt=1;
   else commnt=0;
}

class Inter_Line
{ public: char line[71];
          int loc;
          char label[8];
          char oper[6];
          char operand[19];
          char comment[31];
          int commnt;
          parser(char *);
};

Inter_Line::parser(char *c)
{ int i;

  sscanf(c,"%d",&loc);
  for (i=0;i<8;i++)
  { label[i]=c[i]; line[i]=c[i]; }
  for (;i<14;i++)
  { oper[i-8]=c[i]; line[i]=c[i]; }
  for (;i<33;i++)
  { operand[i-14]=c[i]; line[i]=c[i]; }
  for (;i<67;i++)
  { comment[i-33]=c[i]; line[i]=c[i]; }
  if (c[0]=='.')
   commnt=1;
   else commnt=0;
}

class Source_Code 
{ public:   Source_Code(char *c) { srcfile=fopen(c,"r");
                                   inter=fopen("inter.sic","w");
                                 }

            FILE *srcfile,*inter;
            int LOCCTR;
            int ProgLength;
            int start_addr;
            class Source_Line current;
            int pass_1(void);
};

Source_Code::pass_1(void)
{ char lin[67];
  int i,loc;

  while (fgets(lin,67,srcfile)!=NULL)
  { 
    current.parser(lin);

    if (!strcmp(current.oper,"START"))
    { start_addr=atoi(current.operand);
      LOCCTR=start_addr;
      fprintf(inter,"%d%s\n",LOCCTR,lin);
      continue;
    }
//     else { LOCCTR=0; }
    
    if(!strcmp(current.oper,"END"))
     break;
    loc=LOCCTR;
    if (current.commnt==0)
    { char *found;

      if (current.label!=NULL)
      { int found;

        if ((found=symb_table.search(current.label))!=0)
           /* give_error_message */ ;
         else 
          symb_table.insert(current.label,LOCCTR);
      }
      found=op_table.search(current.oper);
      if (found) 
       LOCCTR+=3;   // problem olabilir
       else { symb_table.insert(current.oper,LOCCTR);
 
              if( !strcmp(current.oper,"WORD"))
               LOCCTR +=3;
        else if( !strcmp(current.oper,"RESW"))
             LOCCTR += 3*atoi(current.operand);
        else if( !strcmp(current.oper,"RESB"))
             LOCCTR += atoi(current.operand);
        else if( !strcmp(current.oper,"BYTE"))
             LOCCTR +=strlen(current.operand)-3;
        else  ; // give error message
            }
      }
    fprintf(inter,"%d%s\n",loc,lin);
    }
    fputs(lin,inter);
    ProgLength=LOCCTR-start_addr;
    fclose(inter);
}
    
class Object_Code
{ public: Object_Code(){ object=fopen("out.obj","w");
                         inter=fopen("inter.sic","r");
                       }

          FILE *object,*inter;
          class Inter_Line current;
          void pass_2(void);
};

void Object_Code::pass_2(void)
{ char lin[67];
  int i=0,line_no,start;
  char *opcode;

  while (fgets(lin,71,inter)!=NULL)
  { 
    current.parser(lin);
    
    if (!strcmp(current.oper,"START"))
    { fprintf(object,"H%s %d\n",current.label,current.loc);
      continue;
    }
    if (!strcmp(current.oper,"END"))
     break;
    if (i%4==0)
    { i=0;
      fprintf(object,"\n");
    }
    i++;
    if (current.commnt==0)
    { char *found;
      
      found=op_table.search(current.oper);
      if (found!=NULL) { 
                         opcode=found;
                         line_no=symb_table.search(current.operand);
                       }  
//       else if(!strcomp(current.oper,"BYTE")||!strcomp(current.oper,"WORD"))
//        ;
    }
    if (i==1)
     fprintf(object,"T %s%d",opcode,line_no);
     else 
      fprintf(object," %s%d",opcode,line_no);
  }
  fclose(inter);
//  inter=fopen("inter.sic,"r");
  fscanf(inter,"%d",&start);
  fclose(inter);
//  fprintf(object,"E%d",start);
  fclose(object);
}

int main(int argc,char *argv[])
{ class Source_Code src(argv[1]);
  class Object_Code obj;

  src.pass_1();
  obj.pass_2();

  return 0;
}
  
