/* MESUT B. CAVLAK  1097146  e109714@ceng.metu.edu.tr  Due : 17th April 2000 */

/* I have only used some iostream functions in the code */
/*

  SOURCE NAME          : hw2.cpp
  INPUT FILE(S)        : <filename>.asm
  INTERMEDIATE FILE(S) : <filename>.ara  ; can also be thougth as an output
  OUTPUT FILE(S)       : <filename>.obj

  This source code can be compiled in UNIX with the below command and arguments
  
       > C++ -o SIC hw2.c -Wall -ansi -g -lm

         C++ can probably be g++ or any other C++ compiler

  There can be more than one source files containing assembly code. The object
  program is written to a file with an extension of .obj . This program also
  creates a intermediate file with an extension of .ara .
  The file pointers of input, output and intermediate files are

      INP -> input file with an extension of .asm
      OUT -> output file with an extension of .obj
      ARA -> intermediate file with an extension of .ara

  The source code must be of the structure below :

    bytes         
    -----    
    1 - 8  label
      9    blank
    10-15  opcode
    16-17  blank
    18-35  operand

  There can't be comment where the instruction is written but there can be
  seperate lines containing comments.

  The assembly directives that this software supports are :
    START, BYTE, WORD, RESB, RESW, END

  The instructions and the above directives must be written in uppercase
  letters but the operands and the labels may be written in either uppercase
  or lowercase letters.

  The comment lines start with the character '.' in the first byte of the
  label field.
*/
/*****************************************************************************/
  #include<ctype.h>
  #include<iostream.h>
  #include<math.h>
  #include<stdio.h>
  #include<stdlib.h>
  #include<string.h>
/*****************************************************************************/
  FILE *INP, *ARA, *OUT;
  long LOCCTR;
  long STRADR;
  int length;
  struct symtable { 
                   char label[8];
                   long where;
                  };
  symtable SYMTAB[500];
  int noofsym;
  char LINE[80];
  char *arafile;
/*****************************************************************************/
  int INPDOGRU(char *inp);
  char * ARAFILE(char *inp);
  char * OUTFILE(char *inp);
  void pass1(void);
  void pass2(void);
  int getline(void);
  char *getlabel(char *);
  char *getopcode(char *);
  char *getoper(char *);
  int putsym(char *label);
  void putsymadr(long adr, char *label);
  long getsymadr(char *label);
  int searchop (char *opcode);
  void errasm (int errno);
  char *longtohex(long adre);
  char *ayarla(char *hexa, int kac);
  char *chartohex(char *inp);
  char inttochar(int inp);
  long hextolong(char *hexa);
/*****************************************************************************/
  int main (int argv, char *argc[])
  {
   if (argv == 1)
     errasm(0);
   for (int i=1 ; i < argv ;i++)
     {
      if (!INPDOGRU(argc[i]))
        { errasm(1); continue; }
      INP = fopen(argc[i],"r");
      if (!INP)
        { errasm(2); continue; }
      arafile = ARAFILE(argc[i]);
      ARA = fopen(arafile,"w");
      if (!ARA)
        { errasm(3); continue; }
      char *outfile = OUTFILE(argc[i]);
      pass1();
      fclose(INP);
      fclose(ARA);
      ARA = fopen(arafile,"r");
      if (!ARA)
        { errasm(3); continue; }
      OUT = fopen(outfile,"w");
      if (!OUT)
        { errasm(4); continue; }
      pass2();
      fclose(ARA);
      fclose(OUT);
     }
   return 0;
  }
/*****************************************************************************/
  int INPDOGRU(char *inp)
  {
   char son[4];
   for (int i=3 ; i >= 0 ; i--)
     son[i] = inp[strlen(inp)-4+i];
   return (strcmp(son,".asm")) ? 0 : 1;
  }
/*****************************************************************************/
  char * ARAFILE(char *inp)
  {
   unsigned i;
   char *arafile;
   arafile = (char *)malloc(sizeof(char)*32);
   for (i=0; i < strlen(inp) ;i++) 
     {
      if (inp[i] == '.')
        break;
      arafile[i] = inp[i];
     }
   arafile[i] = '\0';
   strcat(arafile,".ara");
   return arafile;
  }
/*****************************************************************************/
  char * OUTFILE(char *inp)
  {
   unsigned i;
   char *outfile;
   outfile = (char *)malloc(sizeof(char)*32);
   for (i=0; i < strlen(inp) ;i++) 
     {
      if (inp[i] == '.')
        break;
      outfile[i] = inp[i];
     }
   outfile[i] = '\0';
   strcat(outfile,".obj");
   return outfile;
  }
/*****************************************************************************/
  void pass1(void)
  {
   long PRELOC;
   char * label = new char(8);
   char * opcode = new char(5);
   char * oper = new char(18);
   while ((getline()) == 0);
   label = getlabel(LINE);
   opcode = getopcode(LINE);
   oper = getoper(LINE);
   if (!strcmp(opcode,"START"))
     {
      STRADR = hextolong(oper);
      LOCCTR = hextolong(oper);
      PRELOC = LOCCTR;
      fprintf(ARA,"%ld %s %s   %s\n",LOCCTR,label,opcode,oper);
     }
   else
     LOCCTR = 0;
   while ((getline()) == 0);
   label = getlabel(LINE);
   opcode = getopcode(LINE);
   oper = getoper(LINE);
   while (strcmp(opcode,"END  "))
     {
      if (strcmp(label,"        "))
        {
         int i = putsym(label);
         if (i) errasm(5);
         else putsymadr(LOCCTR,label);
        }
      int var = searchop(opcode);
      if (var != -1) LOCCTR += 3;
      else if (!strcmp(opcode,"WORD ")) LOCCTR += 3;
      else if (!strcmp(opcode,"RESW ")) LOCCTR = LOCCTR + 3 * atoi(oper);
      else if (!strcmp(opcode,"RESB ")) LOCCTR = LOCCTR + atoi(oper);
      else if (!strcmp(opcode,"BYTE "))
        {
         if (oper[0] == 'C' && oper[1] == '\'')
           {
            int i=2;
            for ( ; i < 18 ; i++)
              if (oper[i] == '\'')
                { i = i - 2; break; }
            LOCCTR = LOCCTR + i;
           }
         else if (oper[0] == 'X' && oper[1] == '\'')
           {
            int i=2;
            for ( ; i < 18 ; i=i+2)
              {
               if (oper[i] == '\'')
                 { i = i - 2; break; }
               if (oper[i+1] == '\'')
                 { i = -1; break; }
              }
            if (i >= 0)
              LOCCTR = LOCCTR + i/2;
            else 
              errasm(6);
           }
         else
           errasm(7);
         label = getlabel(LINE);
         opcode = getopcode(LINE);
         oper = getoper(LINE);
        }
      fprintf(ARA,"%ld %s %s   %s\n",PRELOC,label,opcode,oper);
      PRELOC = LOCCTR;
      while ((getline()) == 0);
      label = getlabel(LINE);
      opcode = getopcode(LINE);
      oper = getoper(LINE);
     }
   fprintf(ARA,"     %s %s   %s\n",label,opcode,oper);
   length = LOCCTR - STRADR;
   return;
  }
/*****************************************************************************/
  void pass2(void)
  {
   int kaccar=0;
   int kactane=0;
   int texyaz=0;
   char * satir = new char(80);
   char * YLINE = new char(80);
   char * label = new char(8);
   char * opcode = new char(5);
   char * oper = new char(18);
   char * strt = new char(8);
   char * macode = new char(100);
   char * simdi = new char(6);;
   int wordde=0;
   ARA = fopen(arafile,"r");
   if (!ARA)
     errasm(3);
   fgets(YLINE, 80, ARA);
   sscanf(YLINE,"%s",strt);
   long basla = atoi(strt);
   YLINE = YLINE + strlen(strt) + 1;
   label = getlabel(YLINE);
   opcode = getopcode(YLINE);
   oper = getoper(YLINE);
   strcpy(simdi,oper);
   if (!strcmp(opcode,"START"))
     {
      label[6] = '\0';
      fprintf(OUT,"H%s%s%s\n",label,ayarla(oper,6),ayarla(longtohex(length),6));
     }
   satir[0] = 'T';
   strcpy(satir+1,ayarla(simdi,6));
   fgets(YLINE, 80, ARA);
   sscanf(YLINE,"%s",strt);
   YLINE = YLINE + strlen(strt) + 1;
   label = getlabel(YLINE);
   opcode = getopcode(YLINE);
   oper = getoper(YLINE);
   long adre;                   // adress of the operand from SYMTAB
   macode[0] = '\0';
   while (strcmp(opcode,"END  "))
     {
      int retop = searchop(opcode);
      if (retop >= 0)                        // opcode is found in the OPTAB
        {
         if (wordde)
           { 
            strcpy(simdi,longtohex(atoi(strt)));
            strcpy(satir+1,ayarla(simdi,6));
            wordde = 0;
           }
         int indexed=0;
         if (strlen(oper))
           {
            unsigned i;
            for (i=0 ; i < strlen(oper) ; i++)
               if (oper[i] == ','){ indexed = i; break; }
            oper[i] = '\0';
            int hhh;
            for (hhh=strlen(oper); hhh < 8; hhh++)
              oper[hhh] = ' ';
            oper[hhh] = '\0';
            adre = getsymadr(oper);
            if (adre == -1)
              errasm(8);
            else
              {
               if (indexed)
                 adre = adre + 32768;
               strcat(macode,ayarla(longtohex(retop),2));
               strcat(macode,ayarla(longtohex(adre),4));
               kaccar += 3;
               if (kaccar > 30) { texyaz = 1; kactane = kaccar - 3; }
              }
           }
         else
           {
            strcat(macode,ayarla(longtohex(retop),2));
            strcat(macode,"0000");
            kaccar += 3;
            if (kaccar > 30) { texyaz = 1; kactane = kaccar - 3; }
           }
        }
      else if (!strcmp(opcode,"BYTE ") || !strcmp(opcode,"WORD "))
        {
         if (wordde)
           { 
            strcpy(simdi,longtohex(atoi(strt)));
            strcpy(satir+1,ayarla(simdi,6));
            wordde = 0;
           }
         if (!strcmp(opcode,"BYTE "))
           {
            if (oper[0] == 'C')
              {
               oper[strlen(oper)-1] = '\0';
               oper +=2;
               strcat(macode,ayarla(chartohex(oper),strlen(chartohex(oper))));
               int ss = strlen(chartohex(oper));
               kaccar += ss / 2;
               if (kaccar > 30) { texyaz = 1; kactane = kaccar - ss / 2; }
              }
            else
              {
               oper[strlen(oper)-1] = '\0';
               oper +=2;
               strcat(macode,ayarla(oper,strlen(oper))); 
               kaccar += strlen(oper) / 2;
               if (kaccar > 30) { texyaz = 1; kactane=kaccar-strlen(oper)/2; }
              }
           }
         else
           {
            strcat(macode,ayarla(longtohex(atoi(oper)),6));
            kaccar += 3;
            if (kaccar > 30) { texyaz = 1; kactane = kaccar - 3; }
           }
        }
      else
        {
         if (kaccar)
           { texyaz = 1; kactane = kaccar;}
         wordde = 1;
        }
      if (texyaz == 1)
        {
         char *uzun = ayarla(longtohex(kactane),2);
         satir[7] = uzun[0]; satir[8] = uzun[1];
         strncpy(satir+9,macode,kactane*2);
         satir[9+kactane*2] = '\0';
         macode = macode + kactane*2;
         fprintf(OUT,"%s\n",satir);
         strcpy(simdi,longtohex(atoi(strt)));
         strcpy(satir+1,ayarla(simdi,6));
         kaccar = kaccar - kactane;
         kactane = 0;
         texyaz = 0;
        }
      fscanf(ARA,"%s",strt);
      fgetc(ARA);
      fgets(YLINE, 80, ARA);
      label = getlabel(YLINE);
      if (!strcmp(strt,"END") && !strncmp(label+4,SYMTAB[0].label,4))
        break;
      opcode = getopcode(YLINE);
      oper = getoper(YLINE);
     }
   if (kaccar)
     {
      char *uzun = ayarla(longtohex(kaccar),2);
      satir[7] = uzun[0]; satir[8] = uzun[1];
      strncpy(satir+9,macode,kaccar*2);
      satir[9+kaccar*2] = '\0';
      fprintf(OUT,"%s\n",satir);
     }
   satir[0] = 'E';
   strcpy(satir+1,ayarla(longtohex(basla),6));
   fprintf(OUT,"%s\n",satir);
   return;
  }
/*****************************************************************************/
  int getline(void)
  {
   fgets(LINE, 80, INP);
   return (LINE[0] == '.') ? 0 : 1;
  } 
/*****************************************************************************/
  char *getlabel(char *LINE)
  {
   char *label = new char(8);
   strncpy(label, LINE, 8);
   return label;
  }
/*****************************************************************************/
  char *getopcode(char *LINE)
  {
   char *opcode = new char(5);
   strncpy(opcode, LINE+9, 5);
   for (int i=0; i < 5 ; i++)
     if (opcode[i] == '\n')
       {
        for ( ; i < 5 ; i++)
          opcode[i] = ' ';
        break;
       }
   return opcode;
  }
/*****************************************************************************/
  char *getoper(char *LINE)
  {
   int i;
   char *oper = new char(18);
   if (strlen(LINE) < 17) { oper[0] = '\0'; return oper; }
   for (i = 0 ; i < 18 ; i++)
     if (isspace(LINE[17+i]))
       break;
     else
       oper[i] = LINE[17+i];
   oper[i] = '\0';
   return oper;
  }
/*****************************************************************************/
  int putsym(char *label)
  {
   int exist=0;
   for (int i=0; i < noofsym; i++)
    if (!strcmp(SYMTAB[i].label,label))
      {
       exist = 1;
       errasm(9);
       break;
      }
   if (!exist)
     {
      strcpy(SYMTAB[noofsym].label,label);
      noofsym++;
     }
   return exist;
  }
/*****************************************************************************/
  void putsymadr(long adr, char *label)
  {
   for (int i=0; i < noofsym; i++)
     if (!strcmp(SYMTAB[i].label, label))
       {
        SYMTAB[i].where = adr;
        break;
       }
  }
/*****************************************************************************/
  long getsymadr(char *label)
  {
   for (int i=0; i < noofsym; i++)
     if (!strcmp(SYMTAB[i].label, label))
       return SYMTAB[i].where;
   return -1;
  }
/*****************************************************************************/
  int searchop (char *inp)
  {
   if (!strcmp(inp, "ADD  ")) return 24;
   else if (!strcmp(inp, "AND  ")) return 64;
   else if (!strcmp(inp, "COMP ")) return 40;
   else if (!strcmp(inp, "DIV  ")) return 36;
   else if (!strcmp(inp, "J    ")) return 60;
   else if (!strcmp(inp, "JEQ  ")) return 48;
   else if (!strcmp(inp, "JGT  ")) return 52;
   else if (!strcmp(inp, "JLT  ")) return 56;
   else if (!strcmp(inp, "JSUB ")) return 72;
   else if (!strcmp(inp, "LDA  ")) return 0;
   else if (!strcmp(inp, "LDCH ")) return 80;
   else if (!strcmp(inp, "LDL  ")) return 8;
   else if (!strcmp(inp, "LDX  ")) return 4;
   else if (!strcmp(inp, "MUL  ")) return 32;
   else if (!strcmp(inp, "OR   ")) return 68;
   else if (!strcmp(inp, "RD   ")) return 216;
   else if (!strcmp(inp, "RSUB ")) return 76;
   else if (!strcmp(inp, "STA  ")) return 12;
   else if (!strcmp(inp, "STCH ")) return 84;
   else if (!strcmp(inp, "STL  ")) return 20;
   else if (!strcmp(inp, "STX  ")) return 16;
   else if (!strcmp(inp, "SUB  ")) return 28;
   else if (!strcmp(inp, "TD   ")) return 224;
   else if (!strcmp(inp, "TIX  ")) return 44;
   else if (!strcmp(inp, "WD   ")) return 220;
   else return -1;
  }
/*****************************************************************************/
  void errasm (int errno)
  {
   if (errno == 0)
     cerr << "there should be at least one input file\n";
   else if (errno == 1)
     cerr << "the input file must have an extension of (.asm)\n";
   else if (errno == 2)
     cerr << "couldn\'t open the input file for reading\n";
   else if (errno == 3)
     cerr << "couldn\'t open the intermediate file for writing\n";
   else if (errno == 4)
     cerr << "couldn\'t open the output file for writing\n";
   else if (errno == 5)
     cerr << "duplicate symbol in SYMTAB\n";
   else if (errno == 6)
     cerr << "the hexadecimal number in BYTE is written wrong\n";
   else if (errno == 7)
     cerr << "there is an error in BYTE directive\n";
   else if (errno == 8)
     cerr << "couldn\'t find the symbol in the SYMTAB\n";
   else if (errno == 9)
     cerr << "the symbol already exists in the SYMTAB\n";
   exit (1);
  }
/*****************************************************************************/
  char *longtohex(long adre)
  {
   int i;
   long hexad[4];
   char *returnval = new char(6);
   for (i = 3; i >= 0; i--)
    {
     hexad[i] = adre & 15;
     adre = adre / 16;
    }
   for (i = 0; i <= 3; i++)
    {
     if (hexad[i] < 10)
       returnval[i] = (char)(hexad[i] + '0');
     else
       returnval[i] = (char)(hexad[i] + 'A' - 10);
    }
   return returnval;
  }
/*****************************************************************************/
  char *ayarla(char *hexa, int kac)
  {
   char *yenihex = new char(10);
   int ii = strlen(hexa);
   int jj = kac - ii;
   int k;
   for (k=0 ; k < jj ; k++)
      yenihex[k] = '0';
   for ( ; k < kac ; k++)
      yenihex[k] = hexa[k-jj];
   yenihex[k] = '\0';
   return yenihex;
  }
/*****************************************************************************/
  char *chartohex(char *inp)
  {
   char *out = new char(30);
   int i=0;
   while(inp[i] != '\0')
     {
      int ilk = (int)inp[i];
      out[2*i] = inttochar(ilk / 16);
      out[2*i+1] = inttochar(ilk % 16);
      i++;
     }
   return out;
  }
/*****************************************************************************/
  char inttochar(int inp)
  {
   if (inp<10 && inp>=0)
    return inp+48;
   else if (inp>=10 && inp<=16)
    return inp+55;
   return '\0';
  }
/*****************************************************************************/
  long hextolong(char *hexa)
  {
   long returnval=0;
   int sayi=0;
   char *tekstr;
   int uz = strlen(hexa);
   for (int i=0 ; i < uz ;i++)
     {
      tekstr[0] = hexa[uz-i-1];
      if (tekstr[0] >= '0' && tekstr[0] <= '9')
        sayi = atoi(tekstr);
      else
        sayi = tekstr[0] - 'A' + 10;
      returnval = (long)(returnval + sayi * pow(16,i));
     }
   return returnval;
  }
/*****************************************************************************/

