/* murat demirsoy-e1061548 */
#include "Ass.h"


SourceFile SrcFile;
ObjectCode ObjFile;
AssemblyListing   LstFile;
static SourceLine SrcLine;
Errors Error;
static Assembler  assembler;
OpCodeTable OpcTable;
SymbolTable SymTable;
/************************ the end *********************************/

inline char SourceFile::Open(char *mode) {

if ( (_SrcFile=fopen(SrcFileName,mode))!=NULL) return SUCCESSFUL;

return FAIL;
}

/************************ the end *********************************/

inline char SourceFile::Close() {

if ( (fclose(_SrcFile))== 0 ) return SUCCESSFUL;
_SrcFile=NULL;

return FAIL;
}

/************************ the end *********************************/

inline char SourceFile::Read(char *line) {

if ( fgets(line,MAX_LINE_LENGTH,_SrcFile)== NULL) return FAIL;

return SUCCESSFUL;

}

/************************ the end *********************************/

inline void SourceFile::setFileName(char *srcfile) {

if (strlen(srcfile)<MAX_SRCFILENAME_LENGTH) strcpy(SrcFileName,srcfile);
else printf("filename must no exeed %d characters\n",MAX_SRCFILENAME_LENGTH);

}

/************************ the end *********************************/

inline char SourceLine::_CommentOrEmptyLine() {
int i=0;

while(_Line[i]==' ') i++;
if (_Line[i]=='.')  return TRUE;
if (_Line[i]=='\n') return TRUE;

return FALSE;
}


/************************ the end *********************************/

inline void Token::_ToUpper() {
	for (int i=0; _Token[i]; i++)
		if (_Token[i]>='a' && _Token[i]<='z') _Token[i]=_Token[i] + 'A'-'a';
}

/************************ the end *********************************/

inline char Token::Read() {
int i=0;
int exist=0;

_Token[0]=0;
if (SrcLine._ColCtr < 1) return _Error(0);

while(SrcLine._Line[SrcLine._ColCtr]==' ') SrcLine._ColCtr++;
while(SrcLine._Line[SrcLine._ColCtr]!=' ' &&
	  SrcLine._Line[SrcLine._ColCtr]!='\n') if (i< MAX_OPCODE_LENGTH) { _Token[i++]= SrcLine._Line[SrcLine._ColCtr++]; exist=1;}
                                            else break;

_Token[i]=NULL;

if (exist) _ToUpper();
else return _Error(-1);

return SUCCESSFUL;
}

/************************ the end *********************************/

inline char Token::_Alpha(char ch) { return (ch>='A' && ch<= 'Z'); }

/************************ the end *********************************/

inline char Token::_Numeric(char ch) { return (ch>='0' && ch<= '9'); }

/************************ the end *********************************/

inline char Token::_HexaDecimal(char ch) {
	return ( (ch>='0' && ch<= '9') || (ch>='A' && ch<= 'F') );
}             
                              


/************************ the end *********************************/

inline char OpCode::Read() {
	if (Token::Read()== ERROR ) return ERROR;

	return SUCCESSFUL;
}

/************************ the end *********************************/

inline char Symbol::Read() {
	if (Token::Read()== ERROR ) return ERROR;

	return SUCCESSFUL;
}


/************************ the end *********************************/

inline int Symbol::Pass2() {
	int *symptr;
    
	if (( symptr=SymTable.Search(_Token) )==NULL) _Error(42); /*invalid opcode */
	
	if (symptr!=NULL) return *symptr;
	else return -1;
}

/************************ the end *********************************/

inline OpCodeTable::_Insert(char *name,char type,char *machcode,
						   int machcodelength,int addressfnum,int dirunitlen) {
	OpCodeData opc;
	opc.Type=type;
	if (machcode!=NULL) 
	{
		strncpy(opc.MachineCode,machcode,MAX_MACHINE_CODE_LENGTH-1);
		opc.MachineCode[MAX_MACHINE_CODE_LENGTH-1]=NULL;
	}
	opc.MachineCodeLength=machcodelength;
	opc.AddressFieldsNumber=addressfnum;
	opc.DirectiveUnitLength=dirunitlen;

	HashTable< struct OpCodeData, OPCODE_TABLE_LENGTH >::Insert(name,opc);
}


/************************ the end *********************************/

inline OpCodeTable::OpCodeTable() {
	 
	_Insert("START",START_DIRECTIVE,NULL,0,1,1);
	_Insert("END",END_DIRECTIVE,NULL,0,1,1);

	_Insert("BYTE",BYTE_DIRECTIVE,NULL,0,1,1);
	_Insert("WORD",WORD_DIRECTIVE,NULL,0,1,3);

	_Insert("RESB",RES_BYTE_WORD_DIRECTIVE,NULL,0,1,1);
	_Insert("RESW",RES_BYTE_WORD_DIRECTIVE,NULL,0,1,3);

	_Insert("LDA",INSTRUCTION,"00\0",3,1,0);
	_Insert("STA",INSTRUCTION,"0C\0",3,1,0);
	
	_Insert("LDX",INSTRUCTION,"04\0",3,1,0);
	_Insert("STX",INSTRUCTION,"10\0",3,1,0);
	
	_Insert("LDL",INSTRUCTION,"08\0",3,1,0);
	_Insert("STL",INSTRUCTION,"14\0",3,1,0);
	
	_Insert("ADD",INSTRUCTION,"0?\0",3,1,0);
	_Insert("SUB",INSTRUCTION,"0?\0",3,1,0);
	_Insert("MUL",INSTRUCTION,"0?\0",3,1,0);
    _Insert("DIV",INSTRUCTION,"0?\0",3,1,0);
	_Insert("COMP",INSTRUCTION,"28\0",3,1,0);
	
	_Insert("TIX",INSTRUCTION,"2C\0",3,1,0);

	_Insert("J",   INSTRUCTION,"3C\0",3,1,0);
	_Insert("JEQ", INSTRUCTION,"30\0",3,1,0);
	_Insert("JGT", INSTRUCTION,"0B\0",3,1,0);
	_Insert("JLT", INSTRUCTION,"38\0",3,1,0);
	_Insert("JSUB",INSTRUCTION,"48\0",3,1,0);
	_Insert("RSUB",INSTRUCTION,"4C\0",3,0,0);

    _Insert("LDCH",INSTRUCTION,"50\0",3,2,0);
	_Insert("STCH",INSTRUCTION,"54\0",3,2,0);

	_Insert("TD",INSTRUCTION,"E0\0",3,1,0);
	_Insert("RD",INSTRUCTION,"D8\0",3,1,0);
	_Insert("WD",INSTRUCTION,"DC\0",3,1,0);
	
	
}

inline OpCodeTable::~OpCodeTable() {
}

/************************ the end *********************************/

inline Errors::Errors() {
	_ErrNo=-1;
	for(int i=0;i<ERROR_TABLE_LENGTH;i++)
		_ErrTable[i]=(char *)malloc(MAX_ERR_MESSAGE_SIZE*sizeof(char));
	
	 strcpy(_ErrTable[0], "An opcode or symbol can't start at Column-0");
	 strcpy(_ErrTable[10],"Label must start at Column-0");
	 strcpy(_ErrTable[11],"Invalid Label");
	 strcpy(_ErrTable[12],"Redeclaration of label");
	 strcpy(_ErrTable[20],"Invallid opcode");
	 strcpy(_ErrTable[21],"Invalid OpCode");
	 strcpy(_ErrTable[30],"End directive is required");
	 strcpy(_ErrTable[31],"Illegal End directive(must have a label)");
	 strcpy(_ErrTable[40],"Invalid symbol");
	 strcpy(_ErrTable[41],"Label operand required");
	 strcpy(_ErrTable[42],"Undefined Symbol");
	 strcpy(_ErrTable[45],"Invalid symbol");
	 strcpy(_ErrTable[50],"Numeric operand required");
	 strcpy(_ErrTable[70],"Error converting to object code(operand can't fit into 2 bytes)");

}

/************************ the end *********************************/

inline Errors::~Errors() {

}


/************************ the end *********************************/

inline void Errors::SetErr(int err,char *token) {
	_ErrNo=err;
	if (err!=-1) assembler.AnyError=1;
	if (token!=NULL) strncpy(_ErrToken,token,MAX_TOKEN_LENGTH-1);
}

/************************ the end *********************************/

inline void Errors::Print() {
    if (_ErrNo >=0)
	{
	if (_ErrNo >= ERROR_TABLE_LENGTH ) printf("Line %d: unknown error\n",assembler.Line);
	else if (strcmp(_ErrToken,"")!=0) printf("Line %d :\"%s\": %s\n",assembler.Line,_ErrToken,_ErrTable[_ErrNo]); 
	     else printf("Line %d : %s\n",assembler.Line,_ErrTable[_ErrNo]); 
	assembler.AnyError=1;
	}
	_ErrNo=-1;
	 strcpy(_ErrToken,"");
}

/************************ the end *********************************/

inline char Token::_Error(int errno) {
	
	Error.SetErr(errno,_Token);
	
	return ERROR;
}

/************************ the end *********************************/

inline char Label::Validate() {
	if ( ! _Alpha(_Token[0]) ) return INVALID_LABEL;

	for(int i=0; _Token[i]; i++)
		if ( !_Alpha(_Token[i]) && !_Numeric(_Token[i]) ) return INVALID_LABEL;
	
	return VALID_LABEL;
}


/************************ the end *********************************/

inline char Symbol::ValidateAsLabel() {
	if ( ! _Alpha(_Token[0]) ) 
	{
		Error.SetErr(41,_Token);
		return INVALID_LABEL_SYMBOL;
	}

	for(int i=0; _Token[i]; i++)
		if ( !_Alpha(_Token[i]) && !_Numeric(_Token[i]) )
		{
		Error.SetErr(41,_Token);
		return INVALID_LABEL_SYMBOL;
		};
	
	
	return VALID_LABEL_SYMBOL;
}


inline char Symbol::ValidateAsNumeric() {
	int chars=0, hex=0,i;

	
	for(i=0; _Token[i] ; i++) if (!_Numeric(_Token[i]))
	{
		Error.SetErr(50,_Token);
		return INVALID_NUMERIC_SYMBOL;
	}

	if (i>4) 
	{
		Error.SetErr(50,_Token); 
		return INVALID_NUMERIC_SYMBOL;
	}

	return VALID_NUMERIC_SYMBOL;
}

/************************ the end *********************************/

inline int Symbol::Operand() {
	return atoi(_Token);
}


/************************ the end *********************************/


inline char Label::Read() {

_Token[0]=0;
if (SrcLine._ColCtr != 0) { SrcLine._ColCtr++; return _Error(10);}

if (SrcLine._Line[0]!=' '){

while(SrcLine._Line[SrcLine._ColCtr]!=' ' &&
	  SrcLine._Line[SrcLine._ColCtr]!='\n') if (SrcLine._ColCtr < MAX_LABEL_LENGTH) _Token[SrcLine._ColCtr]= SrcLine._Line[SrcLine._ColCtr++];
                                            else break;
_Token[SrcLine._ColCtr]=NULL;
_ToUpper();
if (Validate()!= VALID_LABEL ) return _Error(11);
}
else { SrcLine._ColCtr++; return _Error(-1);}

return SUCCESSFUL;
}


/************************ the end *********************************/

inline char Comment::Read() {

while(SrcLine._Line[SrcLine._ColCtr]!='\n') SrcLine._ColCtr++;
_Token[0]=NULL;

return SUCCESSFUL;
}

/************************ the end *********************************/

inline char Label::Pass1() {

	if (SymTable.Insert(_Token,assembler.LocCtr)==FAIL) return _Error(12); /* double decl */

	return SUCCESSFUL;
}

/************************ the end *********************************/

inline OpCodeData *OpCode::Pass1() {
	OpCodeData *OpcDataptr;
    
	if (( OpcDataptr=OpcTable.Search(_Token) )==NULL) _Error(21); /*invalid opcode */
	
	return OpcDataptr;
}
	 

/************************ the end *********************************/

inline char SourceLine::New() {

_ColCtr=0;
do { 
	assembler.Line++;
	if (SrcFile.Read(_Line)==FAIL) return FAIL;

   } while(_CommentOrEmptyLine()==TRUE);

 return SUCCESSFUL;
}

/************************ the end *********************************/

inline  SourceLine::SourceLine() {
}

/************************ the end *********************************/

inline  char SourceLine::Pass1() {
	OpCodeData *OpcDataPtr;
	

	if (_Label.Read()==ERROR) Error.Print();
	else if (_Label.Pass1()==ERROR) Error.Print();

	_OpCode.Read();

	OpcDataPtr=_OpCode.Pass1();
	
	
	if (OpcDataPtr==NULL) Error.Print();
	else
		if (OpcDataPtr->AddressFieldsNumber>0)
		{
			_Symbol.Read();
			if (OpcDataPtr->Type==INSTRUCTION)
			{
				if (_Symbol.ValidateAsLabel()!=VALID_LABEL_SYMBOL) Error.Print();
				assembler.LocCtr+= OpcDataPtr->MachineCodeLength;
			}
			else 
				if (OpcDataPtr->Type==BYTE_DIRECTIVE || OpcDataPtr->Type==WORD_DIRECTIVE) 
				{
					if (_Symbol.ValidateAsNumeric()!=VALID_NUMERIC_SYMBOL) Error.Print();
					assembler.LocCtr+=OpcDataPtr->DirectiveUnitLength;
				}
				else 
					if (OpcDataPtr->Type==RES_BYTE_WORD_DIRECTIVE || OpcDataPtr->Type==START_DIRECTIVE)
					{
						if (_Symbol.ValidateAsNumeric()!=VALID_NUMERIC_SYMBOL) Error.Print();
						else assembler.LocCtr+=OpcDataPtr->DirectiveUnitLength*_Symbol.Operand();
					}
    
		}
		else assembler.LocCtr+= OpcDataPtr->MachineCodeLength; 
		
		_Comment.Read();
         
		 
		 if (OpcDataPtr!=NULL) return OpcDataPtr->Type;
		 else return INSTRUCTION;
}

/************************ the end *********************************/

char *strmcat(char *dst,char *src,char mode) {
	int i,ld,ls;
	char *result;

	ld=strlen(dst);
	ls=strlen(src);
	result=(char *)malloc( (ld+ls)*sizeof(char));

	for(i=0;dst[i];i++) result[i]=dst[i];

	for(i=0;src[i];i++) result[ld+i]=src[i];
	result[ld+i]='\0';

	if (mode==1) 
	{
		for(i=0;result[i];i++) dst[i]=result[i];
		dst[i]='\0';
	}

	
	return result;
}

/************************ the end *********************************/


 char *ToHex(int address,char length) {
	char *hexaddress,temp[MAX_INSTRUCTION_SIZE];
	int i,k,v;

	hexaddress=(char *)malloc((MAX_INSTRUCTION_SIZE)*sizeof(char));

	for (i=0;address>=16;address/=16,i++) 
		temp[i]=((v=address%16)<10)?(v+'0'):(v+'A'-10);
	temp[i++]=(address<10)?(address+'0'):(address+'A'-10);

	if (i<=length)
	{
		for(k=i;k<length;k++) hexaddress[k-i]='0';
		for(k=length-i,i=i-1;i>=0;i--,k++) hexaddress[k]=temp[i];
	}
	else for(k=0;k<length;k++) hexaddress[k]='X';

	hexaddress[k]='\0';

	return hexaddress;


}

/************************ the end *********************************/

int HexToInt(char *hex) {
	int i,k,lh,r,result;

	lh=strlen(hex);
	for(result=0,i=lh-1;i>=0;i--)
	{
		r=(hex[i]>='A' && hex[i]<='F')? (hex[i]-'A'+10):(hex[i]-'0');
		for(k=0;k<lh-i-1;k++) r*=16;
		result+=r;
	}

	return result;
}

/************************ the end *********************************/

int HToInt(int hex) {
	int i,k,r,result=0;

	i=0;
	while(hex>=10) 
	{
		r=hex%10;
		for(k=0;k<i;k++) r*=16;
		result+=r;
		hex/=10;
		i++;
	}
	r=hex;
	for(k=0;k<i;k++) r*=16;
	result+=r;

	return result;

}
 
/************************ the end *********************************/

inline  char SourceLine::Pass2(char *Instr) {
	OpCodeData *OpcPtr;
	char temp[MAX_TOKEN_LENGTH];
	char strl;
	int SymAdrs;
	
	
	 

	_Label.Read();

	_OpCode.Read();
	 OpcPtr=_OpCode.Pass1();
	
	 if (OpcPtr->AddressFieldsNumber>0)
	 {
	 _Symbol.Read();

	 if (OpcPtr->Type==INSTRUCTION)
	 {
		 
		 if ( (SymAdrs=_Symbol.Pass2())<0)
		 {
			 Error.Print();
			 strcpy(Instr,strmcat(OpcPtr->MachineCode,"0000",0));
		 }
		 else strcpy(Instr,strmcat(OpcPtr->MachineCode,ToHex(SymAdrs,4),0));
			 
	 }
	 else if (OpcPtr->Type==BYTE_DIRECTIVE) strcpy(Instr,ToHex(_Symbol.Operand(),2) );
		 else if (OpcPtr->Type==WORD_DIRECTIVE) strcpy(Instr,ToHex(_Symbol.Operand(),6) );
		      else Instr[0]='\0';

	 }
	 else strcpy(Instr,strmcat(OpcPtr->MachineCode,"0000",0));

	_Comment.Read();

	
	if ( (strl=strlen(Instr))!=2 && strl!=0 && strl!=MAX_INSTRUCTION_SIZE) 
	{
		if (OpcPtr->AddressFieldsNumber>0) 
		{
			sprintf(temp,"%d",_Symbol.Operand() );
			Error.SetErr(70,temp);
		}
		else Error.SetErr(101,"");
		return ERROR;
	}

	return SUCCESSFUL;
}

/************************ the end *********************************/

inline void Assembler::_GetProgramName() {
	int i;
	if (strlen(SrcLine._Label._Token) > MAX_PROGRAM_NAME_LENGTH)
	{
		strncpy(ProgramName,SrcLine._Label._Token,MAX_PROGRAM_NAME_LENGTH);
	}
	else 
	{
		strcpy(ProgramName,SrcLine._Label._Token);
		for(i=strlen(SrcLine._Label._Token);i<MAX_PROGRAM_NAME_LENGTH;i++)
			ProgramName[i]=' ';
	}
	
	ProgramName[MAX_PROGRAM_NAME_LENGTH]='\0';
}

/************************ the end *********************************/

inline char Assembler::_Pass1() {
	
	char LineType;

	SrcFile.Open("r");
	LocCtr=0;
	AnyError=0;
	Line=0;
	_EndRequired=0;

	if (SrcLine.New()!=FAIL) 
	{
		if (SrcLine.Pass1()==START_DIRECTIVE) 
		{
			 assembler.StartAddress=HToInt(assembler.LocCtr);
			 assembler.LocCtr=assembler.StartAddress;
			_EndRequired=1;
		}
		
		_GetProgramName();
	}


	while( SrcLine.New()!= FAIL) LineType=SrcLine.Pass1();

	if (_EndRequired && LineType!= END_DIRECTIVE) 
	{
		Error.SetErr(30,"");
		Error.Print();
	}
	
	assembler.ProgramLength= assembler.LocCtr - assembler.StartAddress;

	SrcFile.Close();

	return SUCCESSFUL;
}

/************************ the end *********************************/

inline char ObjectCode::Write(char *record) {

if ( fputs(strmcat(record,"\n",0),_SrcFile)== EOF) return FAIL;

return SUCCESSFUL;

}

/************************ the end *********************************/

inline void ObjectCode::Print() {
	char line[MAX_LINE_LENGTH];
	
	if (_SrcFile!=NULL) Close();
	Open("r");
	while(Read(line)!=FAIL) printf("%s",line);
	Close();

}


/************************ the end *********************************/

inline int Assembler::_GetExecAddress() {
	if (SrcLine._Symbol.ValidateAsLabel()!=VALID_LABEL_SYMBOL)
	{ 
		Error.SetErr(31,"");
		return -1;
	}
	else return *(SymTable.Search(SrcLine._Symbol._Token));
}

/************************ the end *********************************/

inline void AssemblyListing::Write(char *instr) {
	fprintf(_SrcFile,"%d\t%s\t%s\t%s\t%s\t%s\n",assembler.Line,ToHex(assembler.LocCtr,4),
		                                    SrcLine._Label._Token,SrcLine._OpCode._Token,
											SrcLine._Symbol._Token,instr);
}

/************************ the end *********************************/


inline char Assembler::_Pass2() {
	char Instr[MAX_INSTRUCTION_SIZE+1];
	char TempText[MAX_TEXT_RECORD_SIZE];
	char Text[MAX_TEXT_RECORD_SIZE];
	char Header[MAX_HEADER_RECORD_SIZE];
	char End[MAX_END_RECORD_SIZE];
	unsigned int TextRecordByteCount;
	int execaddress,notprinted;


	 
	printf(" ------****------- \n");

	SrcFile.Open("r");
	ObjFile.Open("w");
	LstFile.Open("w");

	LocCtr=assembler.StartAddress;
	Line=0;

	strcpy(Header,strmcat("H",strmcat(assembler.ProgramName,
		                              strmcat(ToHex(assembler.StartAddress,6),
									          ToHex(assembler.ProgramLength,6),0
										     ),0
									 ),0
                         )
		  );

	ObjFile.Write(Header);


	strcpy(Text,strmcat("T",ToHex(LocCtr,6),0) );
	TempText[0]='\0';
	Instr[0]='\0';
	End[0]='\0';
	TextRecordByteCount=0;

	while(SrcLine.New()!=FAIL)
	{
		if (SrcLine.Pass2(Instr)==ERROR) { Error.Print(); strcpy(Instr,"XXXXXX"); }
		else if (Instr[0]!=NULL) 
		{
	
		LstFile.Write(Instr);
		LocCtr+=strlen(Instr)/2;
//		sprintf(TempText,"%s%s",TempText,Instr);
		strmcat(TempText,Instr,1);  //?????????/

		TextRecordByteCount+=strlen(Instr);
		notprinted=1;
		if (TextRecordByteCount>50)
		{
//			sprintf(Text,"%s%2s%s",Text,ToHex(TextRecordByteCount,2),TempText);
			strmcat(Text,strmcat(ToHex(TextRecordByteCount,2),TempText,0),1);
			TempText[0]=NULL;
			TextRecordByteCount=0;
			ObjFile.Write(Text);
			notprinted=0;
//			sprintf(Text,"T%6s",LocCtr);
			strcpy(Text,strmcat("T",ToHex(LocCtr,6),0));

		}
		}
	}

	if (notprinted)
	{
		strmcat(Text,strmcat(ToHex(TextRecordByteCount,2),TempText,0),1);
		TempText[0]=NULL;
		TextRecordByteCount=0;
		ObjFile.Write(Text);
		notprinted=0;
	}
		


	if (_EndRequired) 
	{
		if ( (execaddress=_GetExecAddress())<0) Error.Print();
		else 
		{
			strcpy(End,strmcat("E",ToHex(execaddress,6),0));
			ObjFile.Write(End);
		}
		printf("exec at %d\n",execaddress);
	}

	LstFile.Close();
	ObjFile.Close();
	SrcFile.Close();

	return SUCCESSFUL;
}

/************************ the end *********************************/

inline char Assembler::Assemble() {

	_Pass1();
	if (!AnyError) _Pass2();
	if (!AnyError) 
	{
		ObjFile.Print();
		LstFile.Print();
	}
	

	return SUCCESSFUL;
}

/************************ the end *********************************/

inline Assembler::Assembler() {
}



/************************ the end *********************************/

template<class DataStruct, int TableLength> int HashTable<DataStruct,TableLength>::_Hash(char *s) {

 char *p;
 unsigned int h=0,g;

 for(p=s;*p;p++)
 {
  h= (h << 4) + (*p);
  if ( (g = h & 0xf0000000))
  {
   h= h ^ (g >> 24);
   h= h ^ g;
  }
 }
// printf("hash= %d\n",h%TableLength);
 return h % TableLength;
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> DataStruct *HashTable<DataStruct,TableLength>::Search(char *name) {
	int TableIndex;
	char Result;
	LinkedData<DataStruct> *Temp;
	
	TableIndex=_Hash(name);

	for(Temp=_Table[TableIndex];Temp!=NULL;Temp=Temp->Next)
       if (( Result=strcmp(name,Temp->Name) )==0) return &Temp->Data;

    return NULL;
}



/************************ the end *********************************/

template<class DataStruct, int TableLength> char HashTable<DataStruct,TableLength>::Insert(char *name,DataStruct data) {
	int TableIndex;
    LinkedData<DataStruct> *Current;
    LinkedData<DataStruct> *Previous;
	char Result;

	TableIndex=_Hash(name);
	
	for(Previous=Current=_Table[TableIndex];Current!=NULL;Previous=Current,Current=Current->Next)
	if (( Result=strcmp(name,Current->Name) )==0 ) return FAIL;
		else if (Result < 0) break;

	Current=(LinkedData<DataStruct> *)malloc(sizeof(LinkedData<DataStruct>));
	strncpy(Current->Name,name,MAX_LABEL_LENGTH-1);
	Current->Data=data;                
    
	if (Previous==NULL) {
		_Table[TableIndex]=Current;
		Current->Next=NULL;
	}
	else {
		Current->Next=Previous->Next;
		Previous->Next=Current;
	}

	return SUCCESSFUL;
} 
/************************ the end *********************************/

inline void SymbolTable::Print() {
	LinkedData<int> *temp;

	for(int printed=0,i=0;i<SYMBOL_TABLE_LENGTH;i++) {
		if (_Table[i]!=NULL) printf("%d= ", i);
		for(temp=_Table[i];temp!=NULL;temp=temp->Next) {
			printed++; 
			printf("%s",temp->Name);

			if (sizeof(temp->Data)==sizeof(int)) printf(",%s ",ToHex(temp->Data,4));
			printf(" - ");

		}
		
		if (printed>0) {printf("\n");printed=0;}	
	}
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> void HashTable<DataStruct,TableLength>::Print() {
	LinkedData<DataStruct> *temp;

	for(int printed=0,i=0;i<TableLength;i++) {
		if (_Table[i]!=NULL) printf("%d= ", i);
		for(temp=_Table[i];temp!=NULL;temp=temp->Next) {
			printed++; 
			printf("%s",temp->Name);
			if (sizeof(temp->Data)==sizeof(int)) printf(",%d ",temp->Data);
			else printf(" - ");

		}
		
		if (printed>0) {printf("\n");printed=0;}	
	}
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> HashTable<DataStruct,TableLength>::HashTable() {
	for(int i=0;i<TableLength;i++) _Table[i]=NULL;
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> HashTable<DataStruct,TableLength>::~HashTable() {
	LinkedData<DataStruct> *cur, *prev;

	for(int i=0;i<TableLength;i++) 
	{   prev=NULL;
		while (prev!=_Table[i])
		{
			for(prev=cur=_Table[i];cur->Next!=NULL;prev=cur,cur=cur->Next); 
			prev->Next=NULL;
			free(cur);
		}
	}
	
}



/************************ the end *********************************/

void main(int argc, char *argv[]){


if (argc<2) { printf("usage: ass filename\n"); exit(0); }
else SrcFile.setFileName(argv[1]);

ObjFile.setFileName("ASSEMBLER.OBJ");
LstFile.setFileName("ASSEMBLER.LST");

assembler.Assemble();
if (argc>2&&!assembler.AnyError)
{
	SymTable.Print();
	printf("----***---\n");
    OpcTable.Print();
}

}
