#include<iostream.h>

#define FALSE -1 
#define TRUE   1
#define h2 17

typedef struct match {
	char code[5];
	char mcode[3];
 } MATCH;

class opcode {
	MATCH table[67];
	int hash(char *);
	void insert(char *, char *);
	void make();
 public:
	opcode();
	char *search(char *);
 };

int opcode::hash(char name[5])
 {
 int i=0;
 if (strlen(name)<5)
   {
   while (*name) i = i<<1 ^ *name++;
   return i%=67;
   }
 else 
   return FALSE;
 }

void opcode::insert(char name[5], char value[3])
 {
 int h;
 for (h=hash(name); strcmp(table[h].code, ""); h+=h2);
 strcpy(table[h].code, name);
 strcpy(table[h].mcode, value);
 }

void opcode::make(void)
 {
 insert("ADD", "18");insert("AND", "40");insert("COMP", "28");
 insert("DIV", "24");insert("J", "3C");insert("JEQ", "30");
 insert("JGT", "34");insert("JLT", "38");insert("JSUB", "48");
 insert("LDA", "00");insert("LDCH", "50");insert("LDL", "08");
 insert("LDX", "04");insert("MUL", "20");insert("OR", "44");
 insert("RD", "D8");insert("RSUB", "4C");insert("STA", "0C");
 insert("STCH", "54");insert("STL", "14");insert("STSW", "E8");
 insert("STX", "10");insert("SUB", "1C");insert("TD", "E0");
 insert("TOC", "2C");insert("WD", "DC");
 }

char *opcode::search(char opcode[5])
 {
 int h=hash(opcode);
 if (h==FALSE) return NULL;
 for (int i=0; strcmp(table[h].code, opcode); ++i, h+=h2)
   if (i>66 || !strcmp(table[h].code, "")) return NULL;
 return table[h].mcode; 
 }

opcode::opcode()
 {
 make();
 }

typedef struct addres {
	char label[11];
	char addr[5];
	} LABEL;

class symbol {
	int labindex;
	int hash(char *);
	void inttoh(char *, int);
	LABEL table[67];
 public:
	symbol();
	int enter(char *, int); 
	char *search(char *);
 };

int symbol::hash(char *name)
 {
 int i=0;
 if (strlen(name)<11)
   {
   while (*name) i = i<<1 ^ *name++;
   return i%=67;
   }
 else 
   return FALSE;
 }

void symbol::inttoh(char hex[5], int x)
 {
 int rem;
 hex[4]=0;
 rem=x%16; if (rem<10) hex[3]=rem+'0'; else hex[3]=rem-10+'A'; x/=16;
 rem=x%16; if (rem<10) hex[2]=rem+'0'; else hex[2]=rem-10+'A'; x/=16;
 rem=x%16; if (rem<10) hex[1]=rem+'0'; else hex[1]=rem-10+'A'; x/=16;
 rem=x%16; if (rem<10) hex[0]=rem+'0'; else hex[0]=rem-10+'A';
 }

int symbol::enter(char *label, int addr)
 {
 int h=hash(label);
 if (labindex>49) return FALSE;
 if (h==FALSE) return FALSE;
 for (; strcmp(table[h].label, ""); h+=h2);
 strcpy(table[h].label, label);
 inttoh(table[h].addr, addr);
 ++labindex;
 return h;
 }

char *symbol::search(char *label)
 {
 int h=hash(label);
 if (h==FALSE) return NULL;
 for (int i=0; strcmp(table[h].label, ""); ++i, h+=h2)
   if (i>66) return NULL;
 return table[h].addr;
 }

symbol::symbol(void)
 {
 labindex=0;
 }

int main(void)
 {


 }
